
---------------------------------------------------------------------------------
--
-- Add new FRH_PROPERTY entry for Rule Firing Report
--
---------------------------------------------------------------------------------

merge into FRH_PROPERTY 
USING TABLE(values('rule_fire_ext_days'))
                     ac(PROPERTY_NAME) 
                  ON (FRH_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
insert (
    PROPERTY_NAME, PROPERTY_VALUE, PROPERTY_DESC, PROPERTY_LABEL, PROPERTY_TYPE, 
    CREATE_TIMESTAMP, CREATE_USER, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, 
    PROPERTY_EDITABLE_IND, PROPERTY_SUB_TYPE, PROPERTY_SUB_TYPE_LABEL) 
VALUES (
 'rule_fire_ext_days' 
 , '30'
 , 'Number of days to extract for Rule Fire report'
 , 'Days to extract for Rule Fire report'        
 , 'etl'
 ,  CURRENT_TIMESTAMP
 ,  'system'  
 ,  'system'  
 ,  CURRENT_TIMESTAMP  
 , 0
 , '0'
 , '1'
 , 'DEFAULT'
 , 'DEFAULT')
;
commit;


---------------------------------------------------------------------------------
--
-- Insert version release 4.1.0.5 (4.1 M0 HF5)
--
---------------------------------------------------------------------------------

merge into FRH_VERSION p
USING TABLE(values('Base DDL', '4.1.0.5'))
                     ac(VERSION_NAME , VERSION_NUM)
                  ON (p.VERSION_NAME = ac.VERSION_NAME
                      AND p.VERSION_NUM=ac.VERSION_NUM)
when not matched then
insert (
    VERSION_NAME , VERSION_NUM , VERSION_DATE , VERSION_DESC, VERSION_COMPONENT)
VALUES (
        'Base DDL', '4.1.0.5', current_date, '4.1 M0 HF5 DDL', 'DDL')
;

commit;
