---------------------------------------------------------------------------------
--
--  new FCM_PROPERTY entries
--  The following SQL will generate merge statements for the new AGS properties.  
--  The sql will generate a merge for the 4 properites, 1 per distinct PROPERTY_SUB_TYPE 
--  of PROPERTY_TYPE='AGS' and PROPERTY_SUB_TYPE <> 'DEFAULT'
--  The results of this query, should be run against the database.
---------------------------------------------------------------------------------

select distinct 'merge into FCM_PROPERTY
USING TABLE(values ('''||ac.p_name||''','''||PROPERTY_SUB_TYPE||''')) as bc (PROPERTY_NAME,P_SUB)
                  ON (FCM_PROPERTY.PROPERTY_NAME = bc.PROPERTY_NAME AND FCM_PROPERTY.PROPERTY_SUB_TYPE = bc.p_sub)
when not matched then
insert (
    PROPERTY_NAME, PROPERTY_VALUE, PROPERTY_DESC, PROPERTY_LABEL, PROPERTY_TYPE, 
    CREATE_TIMESTAMP, CREATE_USER, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, 
    PROPERTY_EDITABLE_IND, PROPERTY_SUB_TYPE, PROPERTY_SUB_TYPE_LABEL) 
VALUES (
 '''||ac.p_name||''' 
 , '|| case when ac.p_value is null then 'null' else ''''||ac.p_value||'''' end||'
 , '''||ac.p_desc||'''
 , '''||ac.p_label||'''
 , ''AGS''
 ,  CURRENT_TIMESTAMP - CURRENT_TIMEZONE
 ,  CURRENT_USER  
 ,  CURRENT_USER   
 ,  CURRENT_TIMESTAMP - CURRENT_TIMEZONE
 , 0
 , ''0''
 , ''1''
 , '''||PROPERTY_SUB_TYPE||'''
 ,'''||PROPERTY_SUB_TYPE_LABEL||''')
;'
  from fcm_property , (values ('ags_mq_ssl_truststore' , null, 'Defines the location of the SSL Trust Store to be used by MQ'  , 'SSL Trust Store' )
                              ,( 'ags_mq_ssl_keystore' , null  , 'Defines the location of the SSL Key Store to be used by MQ' , 'SSL Key Store' )
                              ,('ags_mq_ssl_cipher_suite' , null  ,'Specifies the SSL Cipher suite used on the MQ channel'  , 'SSL Cipher Suite' )
                              ,('ags_mq_ssl_fips_required', 'FALSE'  , 'Specifies if Fips Required should be enabled on the MQ channel (Default is False)'  , 'SSL FIPs required' )
                      ) as ac(p_name,p_value,p_desc,p_label) 
  where property_type = 'AGS' and PROPERTY_SUB_TYPE <>'DEFAULT'
    ;