---------------------------------------------------------------------------------
--
-- Add new FRH_PROPERTY entry for Rule Firing Report
--
---------------------------------------------------------------------------------

merge into FRH_PROPERTY p
USING (select 'rule_fire_ext_days' as property_name from dual) ac
                  ON (p.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
insert (
    PROPERTY_ID,PROPERTY_NAME, PROPERTY_VALUE, PROPERTY_DESC, PROPERTY_LABEL, PROPERTY_TYPE, 
    CREATE_TIMESTAMP, CREATE_USER, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, 
    PROPERTY_EDITABLE_IND, PROPERTY_SUB_TYPE, PROPERTY_SUB_TYPE_LABEL) 
VALUES (
 property_seq.nextval
 ,'rule_fire_ext_days' 
 , '30'
 , 'Number of days to extract for Rule Fire report'
 , 'Days to extract for Rule Fire report'        
 , 'etl'
 ,  SYS_EXTRACT_UTC(CURRENT_TIMESTAMP) 
 ,  'system'  
 ,  'system'  
 ,  SYS_EXTRACT_UTC(CURRENT_TIMESTAMP) 
 , 0
 , '0'
 , '1'
 , 'DEFAULT'
 , 'DEFAULT')
;
commit;


---------------------------------------------------------------------------------
--
-- Insert version release 4.1.0.5 (4.1 M0 HF5)
--
---------------------------------------------------------------------------------
merge into FRH_VERSION p
USING (select 'Base DDL' as VERSION_NAME,'4.1.0.5' as VERSION_NUM from dual) ac
                  ON (p.VERSION_NAME = ac.VERSION_NAME AND p.VERSION_NUM=ac.VERSION_NUM)
when not matched then
insert (
    VERSION_NAME , VERSION_NUM , VERSION_DATE , VERSION_DESC, VERSION_COMPONENT) 
VALUES (
 	'Base DDL', '4.1.0.5', current_date, '4.1 M0 HF5 DDL', 'DDL')
;
commit;
