---------------------------------------------------------------------------------
--
--  new FCM_PROPERTY entries
--  The following SQL will generate merge statements for the new AGS properties.  
--  The sql will generate a merge for the 4 properites, 1 per distinct PROPERTY_SUB_TYPE 
--  of PROPERTY_TYPE='AGS' and PROPERTY_SUB_TYPE <> 'DEFAULT'
--  The results of this query, captured in the spool ile hf3_property_merge.sql, should be
--  run against the database.
---------------------------------------------------------------------------------





select distinct 'merge into FCM_PROPERTY
USING (select '''||ac.p_name||''' as property_name,'''||PROPERTY_SUB_TYPE||''' as p_sub from dual) ac 
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME AND FCM_PROPERTY.PROPERTY_SUB_TYPE = ac.p_sub)
when not matched then
insert (
    PROPERTY_ID,PROPERTY_NAME, PROPERTY_VALUE, PROPERTY_DESC, PROPERTY_LABEL, PROPERTY_TYPE, 
    CREATE_TIMESTAMP, CREATE_USER, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, 
    PROPERTY_EDITABLE_IND, PROPERTY_SUB_TYPE, PROPERTY_SUB_TYPE_LABEL) 
VALUES (
 property_seq.nextval
 ,'''||ac.p_name||''' 
 , '|| case when ac.p_value is null then 'null' else ''''||ac.p_value||'''' end||'
 , '''||ac.p_desc||'''
 , '''||ac.p_label||'''
 , ''AGS''
 ,  SYS_EXTRACT_UTC(CURRENT_TIMESTAMP)
 ,  ''system''  
 ,  ''system''  
 ,  SYS_EXTRACT_UTC(CURRENT_TIMESTAMP)
 , 0
 , ''0''
 , ''1''
 , '''||PROPERTY_SUB_TYPE||'''
 ,'''||PROPERTY_SUB_TYPE_LABEL||''')
;'
from fcm_property , (select 'ags_mq_ssl_truststore' as p_name, null as p_value
 , 'Defines the location of the SSL Trust Store to be used by MQ' as p_desc
 , 'SSL Trust Store' as p_label from dual
union
select 'ags_mq_ssl_keystore' as p_name, null as p_value
  , 'Defines the location of the SSL Key Store to be used by MQ' as p_desc
 , 'SSL Key Store' as p_label from dual
union
select 'ags_mq_ssl_cipher_suite' as p_name, null as p_value
 ,'Specifies the SSL Cipher suite used on the MQ channel' as p_desc
 , 'SSL Cipher Suite' as p_label from dual
union
select 'ags_mq_ssl_fips_required' as p_name, 'FALSE' as p_value
 , 'Specifies if Fips Required should be enabled on the MQ channel (Default is False)' as p_desc
 , 'SSL FIPs required' as p_label from dual
) ac
where property_type = 'AGS' and PROPERTY_SUB_TYPE <>'DEFAULT';


