CREATE OR REPLACE VIEW FCM_GSU_VW
    ( BUSINESSUNITNAME,GROUPNAME, GROUP_ID, SUPUNAME, SUPFNAME, ANALYSTUNAME,
    ANALYSTFNAME, LSTUPDT_TIMESTAMP )
AS
                select
                        coalesce(g.group_Name, ' ') as businessUnitName,
                        coalesce(t.group_Name, ' ') as groupName,
                        coalesce(ug.team_id,-9999) as group_id,
                        coalesce((select u.user_name from fcm_user u where u.user_id = coalesce(t.supervisor_id, g.supervisor_id) and u.logical_del_ind = '0'),' ') as supUName,
                        coalesce((select upper(rtrim(u.user_last_name) ||', '|| rtrim(u.user_first_name))
                                from fcm_user u where u.user_id = coalesce(t.supervisor_id, g.supervisor_id) and u.logical_del_ind = '0'),'') as supFName,
                        ug.user_name as analystUName,
                        upper(rtrim(ug.user_last_name) ||', '|| rtrim(ug.user_first_name)) as analystFName,
                        ug.lstupdt_timestamp
                from
                        fcm_group t
                                inner join fcm_group g on t.parent_group_id = g.group_id
                                inner join fcm_user ug on t.group_id = ug.team_id and ug.logical_del_ind = '0'
                where
                        g.logical_del_ind = '0' and
                        t.logical_del_ind = '0';

/
show errors;
