
CREATE OR REPLACE TRIGGER TR_BUILD
   AFTER UPDATE OF BUILD_STATUS
   ON FCM_BUILD
   FOR EACH ROW
   WHEN (UPPER (NEW.BUILD_STATUS) = 'COMPLETED')
BEGIN
   INSERT INTO FSX_RULE_PACKAGE (FSX_TRAN_ID,
                                 ALERT_TYPE,
                                 RULE_TYPE_ID,
                                 RULE_TYPE_NAME,
                                 RULE_TYPE_DESC,
                                 RULE_ID,
                                 BASE_RULE_ID,
                                 RULE_VERSION_NBR,
                                 TENANT_MULTI_ORG_ID,
                                 BUSINESS_UNIT_ID,
                                 QUEUE_ID,
                                 SLOT_ID,
                                 RULE_NAME,
                                 RULE_DESC,
                                 RULE_STATE,
                                 RULE_CODE,
                                 RULE_PEND_APPROVAL_IND,
                                 RULE_KEYWORDS,
                                 ITEM_LAST_NOTE_ID,
                                 ITEM_NEXT_TO_LAST_NOTE_ID,
                                 ALERT_REASON,
                                 ACTION_EXIT_REMAINING_RULE_IND,
                                 CHECKOUT_USER,
                                 CHECKOUT_TIMESTAMP,
                                 RULE_ORDER_TYPE,
                                 RULE_ORDER_PRIORITY,
                                 CREATE_USER,
                                 CREATE_TIMESTAMP,
                                 LSTUPDT_USER,
                                 LSTUPDT_TIMESTAMP,
                                 LSTUPDT_NBR,
                                 LOGICAL_DEL_IND,
                                 BUILD_ID,
                                 PACKAGE_TIMESTAMP,
                                 FSX_ACTION_TYPE,
                                 FSX_CREATE_TIMESTAMP)
      SELECT FSX_RULE_PACKAGE_SEQ.NEXTVAL,
             b.alert_TYPE,
             b.rule_type_id,
             c.rule_type_name,
             c.rule_type_desc,
             b.rule_id,
             b.base_rule_id,
             b.rule_version_nbr,
             :NEW.TENANT_MULTI_ORG_ID,
             d.BUSINESS_UNIT_ID,
             b.queue_id,
             d.slot_id,
             b.rule_name,
             b.rule_desc,
             b.rule_state,
             b.rule_code,
             b.rule_pend_approval_ind,
             b.rule_keywords,
             b.item_last_note_id,
             b.item_next_to_last_note_id,
             b.alert_reason,
             b.action_exit_remaining_rule_ind,
             b.checkout_user,
             b.checkout_timestamp,
             b.rule_order_type,
             b.rule_order_priority,
             b.create_user,
             b.create_timestamp,
             b.lstupdt_user,
             b.lstupdt_timestamp,
             b.lstupdt_nbr,
             b.logical_del_ind,
             d.build_id,
             d.create_timestamp,
             'UPDATE',
             SYS_EXTRACT_UTC (CURRENT_TIMESTAMP)
        FROM fcm_base_rule  a,
                 fcm_rule  b,
                 fcm_rule_type  c,
                fcm_build_package  d
            where a.base_rule_id =  b.base_rule_id and
             b.rule_type_id = c.rule_type_id  and
             b.rule_id = d.rule_id and
             d.build_id = :NEW.BUILD_ID;
--    from fcm_base_rule  a,
--                 fcm_rule  b,
--                 fcm_rule_type  c,
--                fcm_build_package  d
--            where a.base_rule_id =  b.base_rule_id and
--             b.rule_type_id = c.rule_type_id  and
--             b.rule_id = d.rule_id
--                         and d.build_id = :NEW.BUILD_ID;

 INSERT INTO FSX_RULE_MULTI_ORG  (
    FSX_TRAN_ID,
    RULE_ID,
    SLOT_ID,
    MULTI_ORG_ID,
    CREATE_USER,
    CREATE_TIMESTAMP,
    LSTUPDT_USER,
    LSTUPDT_TIMESTAMP,
    LSTUPDT_NBR,
    LOGICAL_DEL_IND,
    BUILD_ID,
    FSX_ACTION_TYPE,
    FSX_CREATE_TIMESTAMP)
            select
                   FSX_RULE_MULTI_ORG_SEQ.NEXTVAL,
                   b.rule_id,
                   d.slot_id,
                   c.multi_org_id,
                   b.create_user,
                   b.create_timestamp,
                   b.lstupdt_user,
                   b.lstupdt_timestamp,
                   b.lstupdt_nbr,
                   b.logical_del_ind,
                   d.build_id,
     'UPDATE',
     SYS_EXTRACT_UTC(CURRENT_TIMESTAMP )
            from
                 fcm_rule  b,
                 fcm_rule_multi_org  c,
                fcm_build_package  d
            where
             b.rule_id = c.rule_id and
             b.rule_id = d.rule_id and
	         d.build_id = :NEW.BUILD_ID;

  INSERT INTO FSX_RULE_COMP_VALUE  (
    FSX_TRAN_ID,
    RULE_ID,
    SLOT_ID,
    COMPONENT_VALUE_ID,
    CREATE_USER,
    CREATE_TIMESTAMP,
    LSTUPDT_USER,
    LSTUPDT_TIMESTAMP,
    LSTUPDT_NBR,
    LOGICAL_DEL_IND,
    BUILD_ID,
    FSX_ACTION_TYPE,
    FSX_CREATE_TIMESTAMP)
            select
                   FSX_RULE_COMP_VALUE_SEQ.NEXTVAL,
                   b.rule_id,
                   d.slot_id,
                   c.COMPONENT_VALUE_ID,
                   b.create_user,
                   b.create_timestamp,
                   b.lstupdt_user,
                   b.lstupdt_timestamp,
                   b.lstupdt_nbr,
                   b.logical_del_ind,
                   d.build_id,
     'UPDATE',
     SYS_EXTRACT_UTC(CURRENT_TIMESTAMP )
            from
                 fcm_rule  b,
                 fcm_rule_component  c,
                fcm_build_package  d
            where
             b.rule_id = c.rule_id and
             b.rule_id = d.rule_id and
             d.build_id = :NEW.BUILD_ID;

  Insert into fsx_user_variable
  (
  FSX_TRAN_ID,
  BUILD_ID,
  begin_build_id,
  END_BUILD_ID,
  TENANT_MULTI_ORG_ID,
  USERVAR_LENGTH,
  USERVAR_FIELD_NAME,
  USERVAR_BUS_NAME,
  USERVAR_DESC,
  USERVAR_INITIAL_VALUE,
  VARIABLE_TYPE,
  SEGMENT_ACRONYM,
  EXPOSE_USERVAR_IND,
  CREATE_TIMESTAMP,
  LSTUPDT_TIMESTAMP,
  CREATE_USER,
  LSTUPDT_NBR,
  LSTUPDT_USER,
  LOGICAL_DEL_IND,
  FSX_ACTION_TYPE,
  FSX_CREATE_TIMESTAMP)
  select 
   fsx_user_variable_seq.NEXTVAL,
   :NEW.BUILD_ID,
   a.begin_build_id,
   a.END_BUILD_ID,
   :NEW.TENANT_MULTI_ORG_ID,
   a.FIELD_LENGTH,
   a.FIELD_NAME,
   a.FIELD_BUSINESSNAME,
   a.FIELD_DESC,
   a.FIELD_INITIAL_VALUE,
   a.VARIABLE_TYPE,
   sd.SEGMENT_ACRONYM,
   a.EXPOSE_USERVAR_IND,
   a.CREATE_TIMESTAMP,
   a.LSTUPDT_TIMESTAMP,
   a.CREATE_USER,
   a.LSTUPDT_NBR,
   a.LSTUPDT_USER,
   a.LOGICAL_DEL_IND,
   'UPDATE',
   SYS_EXTRACT_UTC(CURRENT_TIMESTAMP )
  from fcm_segment_definition sd, fcm_field_definition a,fcm_segment_key_field skf
   where
   a.begin_build_id is not NULL
   and (a.end_build_id is NULL OR
    	a.end_build_id < :NEW.BUILD_ID
-- Originally want to do this, but because Oracle error ORA-04091: table is mutating trigger, cannnot
-- 		(select max(build_id) from fcm_build 
--    					where tenant_multi_org_id = :NEW.TENANT_MULTI_ORG_ID 
--    					and build_id < :NEW.BUILD_ID)
		)  
   and a.logical_del_ind = '0'
   and a.segment_id = sd.segment_id
   and sd.TENANT_MULTI_ORG_ID = :NEW.TENANT_MULTI_ORG_ID
      and skf.segment_id = sd.segment_id
      and skf.logical_del_ind = '0';
END;
/
SHOW ERRORS;
